/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	チェッククラス
//			変更履歴
//				2004.01.08	新規作成	二條智文
//
package jp.co.ntt.lms.xmo.util;

/**
 * XMSⅡでの各種入力チェックをするユーティリティクラスです。
 * @author T.Nijou
 * @version 0.0.0.1
 */
public class XMOCheck {

	/** チェック正常時 */
	public static final int CHECK_OK = 0;
	/** バイト長チェック */
	public static final int CHECK_LENB = 1 << 0;
	/** 必須入力チェック */
	public static final int CHECK_HISSU = 1 << 1;
	/** 日付チェック */
	public static final int CHECK_DATE = 1 << 2;

	/**
	 * 入力チェックを行います
	 * バイト長チェックはデフォルトで行います
	 * @param strCheck チェック文字列
	 * @param intLength フィールドのバイト長
	 * @param intKind チェック種別
	 * @return int エラーのあったチェック種別を返します
	 */
	public static final int check( String strCheck, int intLength, int intKind ) {

		// 必須入力チェック
		if( ( intKind & CHECK_HISSU ) > 0 ) {

			if( !checkHissu( strCheck ) ) {
				// 必須入力エラー
				return CHECK_HISSU;
			}

		}

		// バイト長チェック（デフォルトで行います）
		if( !checkLenB( strCheck, intLength ) ) {
			// バイト長チェックエラー
			return CHECK_LENB;
		}

		// 日付チェック
		if( ( intKind & CHECK_DATE ) > 0 ) {

			if( !checkDate( strCheck ) ) {
				// 日付チェックエラー
				return CHECK_DATE;
			}

		}
		return CHECK_OK;
	}

	/**
	 * デフォルトで、バイト長チェックのみ行います<BR>
	 * @param intLength フィールドのバイト長
	 * @param intKind チェック種別
	 * @return int エラーのあったチェック種別を返します
	 */
	public static final int check( String strCheck, int intLength ) {
		return check( strCheck, intLength, 0 );
	}

	/**
	 * 必須入力チェックを行います<BR>
	 * 文字列がnull、空文字、半角スペースのみの場合、エラーを返します
	 * @param strCheck チェック文字列
	 * @return boolean true: OK false: NG
	 */
	public static boolean checkHissu( String strCheck ) {
		if( strCheck == null || strCheck.trim().equals( "" ) ) {
			return false;
		}
		return true;
	}

	/**
	 * バイト長チェックを行います
	 * @param strCheck チェック文字列
	 * @param intLength バイト長
	 * @return boolean true: OK false: NG
	 */
	public static boolean checkLenB( String strCheck, int intLength ) {
		if( strCheck == null || strCheck.equals( "" ) ) {
			return true;
		}

		byte[] bytLenB = strCheck.getBytes();

		if( bytLenB.length > intLength ) {
			return false;
		}
		return true;
	}

	/**
	 * 正しい日付かどうかの日付チェックを行います
	 * @param strCheck チェック文字列
	 * @return boolean true: OK false: NG
	 */
	public static boolean checkDate( String strCheck ) {
		if( strCheck == null || strCheck.equals( "" ) ) {
			return true;
		}

		if( XMODate.isDate( strCheck ) ) {
			return true;
		}
		return false;
	}

	/**
	 * 数値チェックを行います。
	 * @param strCheck チェック文字列
	 * @param isInteger true: 整数チェック　false: 実数チェック
	 * @return boolean true: OK fales: NG
	 */
	public static boolean checkNumeric( String strCheck, boolean isInteger ) {
		if( strCheck == null || strCheck.equals( "" ) ) {
			return true;
		}

		try {
			if( isInteger ) {
				new Integer( strCheck );
			}
			else {
				new Double( strCheck );
			}
		}
		catch( NumberFormatException e ) {
			return false;
		}

		return true;
	}
}


